<template>
    <div>
        <crumbs title="分诊人体图数据维护" minWidth="995px">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="医学标准术语：">
                    <el-input size="mini" v-model="filter.term" placeholder="输入术语"></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <!-- <el-button size="mini" type="warning" style="margin:0 10px"  @click="addMedicalMultR">添加</el-button> -->
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table :data="list"
                      border
                      style="width: 100%">
                <el-table-column
                        type="index"
                        :index="indexMethod"
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        prop="operTime"
                        label="操作时间"
                        :show-overflow-tooltip="true">
                </el-table-column>
                <el-table-column
                        prop="libNameType"
                        label="医学标准术语"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        prop="otherNames"
                        label="一级关联标准术语"
                        show-overflow-tooltip>
                </el-table-column>
                <!-- <el-table-column
                        label="状态">
                        <template slot-scope="scope">
                          <span :class="scope.row.isDeleted == 'N'?'':'delete'">
                            {{scope.row.isDeleted == 'N'?'启用中':'已删除'}}
                          </span>
                        </template>
                </el-table-column> -->
                <el-table-column
                        prop="operName"
                        label="操作人">
                </el-table-column>
                
                <el-table-column
                        label="操作" width="160">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click="toEditProduct(scope.row)">修改</el-button>
                        <!-- <span style="margin:0 3px;">|</span>
                        <el-button type="text" size="small" :class="scope.row.isDeleted == 'N'?'delete':'review'" @click="showDelDialog(scope.row)">{{scope.row.isDeleted == 'N'?'删除':'恢复'}}</el-button> -->
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination v-if="total>pageSize"
                           :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           layout="total,prev, pager, next, jumper"
                           :total="total">
            </el-pagination>
        </div>

    </div>
</template>

<script>
  import api from '@api/icss.js';
  export default {
    name: 'MedicalName',
    data: function () {
      return {
        list: [],
        stateSelect:[
          {id:'N',name:'启用中'},
          {id:'Y',name:'已删除'},
        ],
        isState:'',
        cacheData: {},
        currentPage: 1,
        pageSize: 10,
        total: 0,
        searched: false,
        filter: {
          term:'',
          type:''
        },
        typeList:[]
      }
    },
    created() {
      const that = this;
      //返回时避免参数未赋值就获取列表
      setTimeout(function(){
        that.getDataList();
      });
      this.getTypeList();
    },
    watch: {
      'filter': {
        handler: function () {
          this.searched = false;
        },
        deep: true
      }
    },
    beforeRouteEnter(to, from, next){
      next(vm => {
        //const pm = to.param;
        Object.assign(vm,to.params);
      })
    },
    methods: {
      addMedicalMultR(){
        const pam = this.searched ? {
          currentPage: this.currentPage,
          filter: this.filter
        } : {currentPage: this.currentPage};
        this.$router.push({name:'AddMedicalMultRelation',
          params:pam});
      },
      toEditProduct(row){
        const param = {
          conceptId: row.conceptId,
          relationIds: [17,17],
          typeIds: [3,1]
        };
        const pam = this.searched ? {
          currentPage: this.currentPage,
          filter: this.filter
        } : {currentPage: this.currentPage};
        api.relationContactDetail(param).then((res) => {
          const {code,data,msg} = res.data;
          if(code=='0'){
              const item = Object.assign({},row,data);
              this.$router.push({name:'AddMedicalMultRelation',params:Object.assign(pam, {isEdit: true, data: item})});
          }else{
              this.$message({
              message: msg,
              type: 'warning'
              });
          }
        })
      },
      filterDatas(){
        this.currentPage = 1;
        this.getDataList();
      },
      getDataList(isTurnPage) {
        const param = this.getFilterItems(isTurnPage);
        this.searched = true;
        api.multContactList(param).then((res) => {
          if (res.data.code == '0') {
            const data = res.data.data;
            this.list = data.records;
            this.cacheData[param.current] = data.records;
            this.total = data.total;
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getTypeList(){
        api.allKnowledgeType({'name':''}).then((res)=>{
          const data = res.data;
          if(data.code==0){
            this.typeList = data.data;
          }else{
            console.log(res.msg);
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      /*getDetailList(id) {
        this.$router.push({name:'DeptInfoDetail', params:{id: id}})
      },*/
      getFilterItems(isTurnPage) {
        //翻页时筛选条件没点确定则清空
        if(isTurnPage&&!this.searched){
          this.clearFilter();
        };
        const param = {
          name: this.filter.term,
          current: this.currentPage,
          size: this.pageSize,
          type: this.filter.type,
          isDeleted: this.isState,
          relationId: 17,
          startTypeIds: [52]
        };
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      currentChange(next) {
        this.currentPage = next;
        if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
          this.list = this.cacheData[next];
        } else {
          this.getDataList(true);
        }
      },
      warning(msg,type){
        this.$message({
          showClose: true,
          message:msg,
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(item){
        /*const param = {
          term:item.term,
          type:item.type,
          id:item.id
        }*/
        const param = {
          conceptId:item.conceptId,
          // isDeleted:item.isDeleted === 'N'?'Y':'N',
          relationIds: [17,17],
          typeIds: [3,1]
        }
        let waringTxt = '是否删除该关系，可能对现有系统造成影响'
        this.showConfirmDialog(waringTxt,()=>{
          api.removeRelationContact(param).then((res)=>{
            if(res.data.code=='0'){
              if(!this.searched){
                //未点确认时清空搜索条件
                this.clearFilter();
              }
              if(this.list.length==1){
                //当前在最后一页且只有一条数据时，删除后跳到前一页
                this.currentPage = this.currentPage===1?1:this.currentPage-1;
              }
              this.warning(res.data.msg||'操作成功','success');
              this.getDataList();
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      },
      clearFilter(){
        this.filter={
          term:'',
          type:''
        };
      },
      uploadClick(){
        let inp = document.getElementById("upFile");
        inp.click();
      },
      uploadFile(e){
        let fileInfo = e.target.files[0];
        e.preventDefault();
        let formData = new FormData();
        formData.append('uploadfile', fileInfo);
        const header = {
          headers:{
            'Content-Type': 'multipart/form-data'
          }
        }
        api.knowledgeUpload(formData,header).then((res)=>{
          if(res.data.code==0){
            this.$message({
              message: '上传成功',
              type: 'success',
            });
            this.getDataList();
          }else{
            this.$message({
              dangerouslyUseHTMLString: true,
              message:res.data.msg,
              type:'warning'
            });
          }
        })
        
        //解决上传相同文件不触发change
        let inp = document.getElementById("upFile");
        inp.value = "";   
      },
    }
  }
</script>

<style lang="less" scoped>
    @import "../../less/admin.less";
    .delete{
        color: red;
    }
    .review{
      color: #22ccc8;
    }
    .el-table .cell{
      overflow: hidden;
      white-space: nowrap;
    }
    #upFile{
      display: none !important;
    }
</style>
